import usb
import os,sys
import pygame
import random
from pygame.locals import *

####################################
VENDOR_RQ_SET_LED    = 0
VENDOR_RQ_GET_SWITCH = 1
VENDOR_RQ_GET_LIGHT  = 2

####################################
class Board:
    def __init__(self):
        #print "Looking for MCU board..."
        dev = self.find_board()
        if not dev: raise "MCU board not found!"
        #print "MCU board found"
        self.handle = dev.open()

    def find_board(self):
        for bus in usb.busses():
            for dev in bus.devices:
                if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                    return dev
        return None

    def set_led(self,pin,val):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
        self.handle.controlMsg(reqType, VENDOR_RQ_SET_LED, None, value=val*256+pin)

    def get_switch(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH, 1)
        return buf[0]

    def get_light(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT, 2)
        return (buf[1]<<8) + buf[0]

########################GAME MAIN##########################

#Drawing
class Sprite():
	def __init__(self, start_x, start_y, imagename):
		self.x = start_x
		self.y = start_y		
		self.imagename = imagename
		self.sprite = pygame.image.load(self.imagename).convert_alpha()		
	def render(self):
		screen.blit(self.sprite, (self.x, self.y))
		if self.imagename == 'mini2.png' or self.imagename == 'big2.png'  :
			screen.blit(self.sprite, (self.x+500, self.y))
			
			if 'mini2' in self.imagename:
				self.x-=2
			elif 'big2' in self.imagename:
				self.x-=4	
		if self.x < -500: 
   			self.x = 0
		if self.imagename == 'basic.png':
			self.x -=1
		if self.imagename == 'hard.png':
			self.x -=2
		if self.imagename == 'life.png':
			self.x -=1
############### Function Main ###############
#ENEMIES
def add_enemies():
	q=0
	global count ,dismax,enemy_list,xx
	rannum = random.randint(1,100)
	if rannum == 13:
	 rannum2 = random.randint(1,100)
	 if rannum2 %7 ==0:
	 		item_list.append(Sprite(random.randrange(470, 540), random.randrange(0, 500), 'life.png')) 	
	if rannum == 1:
	 enemy_list.append(Sprite(random.randrange(470, 540), random.randrange(0, 500), 'basic.png')) 	
	 count+=1
	if rannum %10 == 0 and count <=dismax:
	 enemy_list.append(Sprite(random.randrange(470, 540), random.randrange(475, 490), 'basic.png'))
	if count >= dismax:
 	 q=1*xx
 	 rannum = random.randint(1,100)
	 if rannum %10 == 0:
	  enemy_list.append(Sprite(random.randrange(320, 400), random.randrange(0, 500), 'hard.png'))
	if q==1:
	  boss_list.append(Sprite(400, 240, 'boss.png'))
	  enemy_list=[]
	  xx=0

#SHON
def shon(pos_x, pos_y, obj_x, obj_y): #shon detect 
	if (pos_x > obj_x-14) and (pos_x <obj_x+14) and (pos_y > obj_y-14) and (pos_y < obj_y +14):
		return True
	else:
		return False
def shonboss(pos_x, pos_y, obj_x, obj_y): #shon detect 
	if (pos_x > obj_x-20) and (pos_x <obj_x+20) and (pos_y > obj_y-20) and (pos_y < obj_y +20):
		return True
	else:
		return False
############### Main ###############
b = Board()
summ=0
for x in range(20):
 summ+=b.get_light()
maxx=summ/20
maxx-=maxx/7
m=0
pygame.init()
clock = pygame.time.Clock()
screen = pygame.display.set_mode((500, 500), 0, 32)
my_font = pygame.font.SysFont('arial', 20)
############### Variable ############### 
speed = 2	
move_x, move_y = 0, 0	
enemy_list = []
boss_list = []
item_list = []
score = 0
xx=1
life = 100
dismax=100
count=0
hpboss=100
bullets = []
bullet_wait = 0
mini = Sprite(0, 0, 'mini2.png')
big = Sprite(0, -40, 'big2.png')
ship = Sprite(50, 100, 'ship-norm.png')
chh=0
running = True
################# MAIN ###############
text = my_font.render( 'PRESS SPACE TO FIRE ', True, (255, 255, 255), (100, 100, 100))
while running:
        add_enemies()
	screen.fill((10, 0, 15))
	for event in pygame.event.get():
		if event.type == QUIT:
			running = False
		if event.type == KEYDOWN:
			if event.key == K_q:
				pygame.quit()
			if event.key == K_SPACE:
				text = my_font.render( '', True, (255, 255, 255), (100, 100, 100))
				if bullet_wait< 1:
					bullets.append(Sprite(ship.x, ship.y, 'bullet.png'))
				bullet_wait+=8
			if event.key == K_r:
			 text = my_font.render( '', True, (255, 255, 255), (100, 100, 100))
			 life=100
			 speed = 2	
			 move_x, move_y = 0, 0	
			 enemy_list = []
			 boss_list = []
			 score = 0
			 life = 100
			 hpboss=100
			 bullets = []
			 bullet_wait = 0
			 chh=0
			 mini = Sprite(0, 0, 'mini2.png')
			 big = Sprite(0, -40, 'big2.png')
			 ship = Sprite(50, 100, 'ship-norm.png')
        a=b.get_light()
 	if a>maxx :
 	 m+=1  
 	if m>22  : # confirm down
 	 move_y = 1
	 m=0
	if a<maxx+5 :
 	 move_y = -1
         m=0
        ship.y += (move_y * speed)
##SET Screen
	if bullet_wait > 0: bullet_wait -=1
	if ship.y > 490: ship.y -= 5
	if ship.y < 10: ship.y += 5
	life_meter = my_font.render('Life: %d'%life, True, (255, 255, 255), (100, 100, 100))
	score_meter = my_font.render('Distance: %d'%count, True, (255, 255, 255), (100, 100, 100))
	boss_meter = my_font.render('HP BOSS: %d'%hpboss, True, (255, 255, 255), (100, 100, 100))
	mini.render()
	big.render()
	for boss in boss_list:		
		boss.render()
	for item in item_list:		
		item.render()
	for enemy in enemy_list:
		enemy.render()
		if enemy.x < -10: 
		 enemy_list.remove(enemy)
		
	ship.render()
        screen.blit(text, (150, 100))
	screen.blit(life_meter, (60, 0))
	screen.blit(score_meter, (150, 0))
        if chh==1 :
 	 screen.blit(boss_meter, (300, 0))	 
	if len(bullets) >0:
		for bullet in bullets:
			bullet.render()
			bullet.x += 7
			if bullet.x > 500: 
				bullets.remove(bullet)
			for enemy in enemy_list:
				if shon(enemy.x, enemy.y, bullet.x, bullet.y):
					enemy_list.remove(enemy)
					bullet.x=500;   
					count+=2;
			for boss in boss_list:
				chh=1
				if shonboss(boss.x, boss.y, bullet.x, bullet.y):
					bullet.x=500;   
					hpboss-= random.randint(1,5);	
					if hpboss <=0:		
					 boss_list.remove(boss)	
					 boss_list.append(Sprite(400, 240, 'boss2.png'))
	for enemy in enemy_list:
		if shon(ship.x, ship.y, enemy.x, enemy.y):
		 life -= random.randint(1,5)
		 enemy_list.remove(enemy)
		 if life < 0: 
		  text = my_font.render( 'YOU LOSE PRESS R TO RESTART ', True, (255, 255, 255), (100, 100, 100))
	for item in item_list:		
		if shon(ship.x, ship.y, item.x, item.y):
		 life +=20
		 item_list.remove(item)
		 text = my_font.render( 'LIFE+20', True, (255, 255, 255), (100, 100, 100))
	if hpboss<=0:
	  text = my_font.render( 'YOU WIN PRESS R TO RESTART ', True, (255, 255, 255), (100, 100, 100))
	clock.tick(60)
	pygame.display.update()

